<template>
  <b-form @submit.prevent="onValidateFormSubmit">
    <!-- First Name -->
    <b-form-group
      label-cols="2"
      horizontal
      :label="$t('guest.name')"
      class="error-l-275 tooltip-label-right"
    >
      <b-form-input
        type="text"
        v-model.trim="horizontalForm.guest_name"
        :placeholder="$t('guest.name')"
      />
    </b-form-group>
    <!-- Email -->
    <b-form-group
      label-cols="2"
      horizontal
      :label="$t('guest.email-address')"
      class="error-l-275 tooltip-label-right"
    >
      <b-form-input
        type="text"
        v-model.trim="$v.horizontalForm.email_address.$model"
        :state="!$v.horizontalForm.email_address.$error"
        :placeholder="$t('guest.email-address')"
      >
      </b-form-input>
      <b-form-invalid-feedback v-if="!$v.horizontalForm.email_address.email">{{
        $t("validation.email")
      }}</b-form-invalid-feedback>
    </b-form-group>
    <!-- Contact Number -->
    <b-form-group
      label-cols="2"
      horizontal
      :label="$t('guest.contact-number')"
      class="error-l-275 tooltip-label-right phone"
    >
      <vue-country-code
        :defaultCountry="horizontalForm.iso"
        :enabledFlags="false"
        :enabledCountryCode="true"
        :disabledFetchingCountry="true"
        ref="phone"
      >
      </vue-country-code>
      <b-form-input
        type="text"
        v-model.trim="$v.horizontalForm.contact_number.$model"
        :state="!$v.horizontalForm.contact_number.$error"
        :placeholder="$t('guest.mobile-number')"
      >
      </b-form-input>
      <b-form-invalid-feedback
        v-if="!$v.horizontalForm.contact_number.numeric"
        >{{ $t("validation.phone-numeric") }}</b-form-invalid-feedback
      >
      <b-form-invalid-feedback
        v-else-if="!$v.horizontalForm.contact_number.phoneFormat"
        >{{ $t("validation.phone-format") }}</b-form-invalid-feedback
      >
    </b-form-group>
    <!-- Save Changes -->
    <submit-button
      :submitting="submitting"
      :successMsg="successMsg"
      :errorMsg="errorMsg"
    >
    </submit-button>

    <!-- Confirm Modal -->
    <b-modal
      id="modalbasic"
      ref="modalbasic"
      hide-footer
      :title="$t('guest.confirm-changes')"
    >
      <p>{{ $t("guest.confirm-changes-message") }}</p>
      <div class="inline-btn">
        <b-button
          type="submit"
          variant="primary"
          class="mt-4"
          :disabled="submitting"
          :class="{
            'btn-multiple-state btn-shadow': true,
            'show-spinner': submitting,
            'show-success': !submitting && errorMsg === false,
            'show-fail': !submitting && errorMsg,
          }"
          @click="confirmChanges()"
        >
          <span class="spinner d-inline-block">
            <span class="bounce1"></span>
            <span class="bounce2"></span>
            <span class="bounce3"></span>
          </span>
          <span class="icon success">
            <i class="simple-icon-check"></i>
          </span>
          <span class="icon fail">
            <i class="simple-icon-exclamation"></i>
          </span>
          {{ $t("button.confirm") }}
        </b-button>
        <b-button variant="light" class="mt-4" @click="hideModal('modalbasic')">
          {{ $t("button.cancel") }}
        </b-button>
      </div>
    </b-modal>
  </b-form>
</template>

<script>
import vSelect from "vue-select";
import "vue-select/dist/vue-select.css";
import { validationMixin } from "vuelidate";
import VueCountryCode from "vue-country-code";
import { mapGetters, mapActions } from "vuex";
import SubmitButton from "../../components/Buttons/SubmitButton.vue";

const { email, numeric, helpers } = require("vuelidate/lib/validators");
const phoneFormat = helpers.regex("phoneFormat", /^[1-9]\d{6,}$/);
export default {
  components: {
    SubmitButton,
    VueCountryCode,
    vSelect,
  },
  props: ["formType", "guest"],
  data() {
    return {
      submitting: false,
      successMsg: "",
      errorMsg: "",
      confirmSubmit: false,
      horizontalForm: {
        ...this.guests,
      },
    };
  },
  mixins: [validationMixin],
  validations: {
    horizontalForm: {
      email_address: {
        email,
      },
      contact_number: {
        numeric,
        phoneFormat,
      },
    },
  },
  computed: {
    ...mapGetters([
      "currentUser"
    ]),
    groupLabel() {
      const selectedCategory = this.accountCategoryOptions.find(
        (category) => category.value === this.horizontalForm.account_category_id
      );
      const categoryText = selectedCategory ? selectedCategory.text : "";
      return `${this.$t("guest.group")} (${categoryText})`;
    },
  },
  methods: {
    ...mapActions([
      "editGuest"
    ]),

    async onValidateFormSubmit(val) {
      this.$v.$touch();
      // Edit Form Submission
      const allFieldsValid = Object.keys(this.$v.horizontalForm).every(
        (field) => !this.$v.horizontalForm[field].$error
      );
      if (allFieldsValid) {
        if (val !== "skipModal") {
          this.somethingModal("modalbasic");
        }
        if (this.confirmSubmit) {
          this.submitting = true;
          try {
            await this.editGuest({
              ...this.horizontalForm,
              phone_code: this.$refs.phone?.activeCountry.dialCode
                ? this.$refs.phone.activeCountry.dialCode
                : this.horizontalForm.phone_code,
            });
            this.successMsg = "Guest updated successfully";
            this.submitting = false;
            this.$notify("success filled", "Success", this.successMsg, {
              duration: 3000,
              permanent: false,
            });
            this.hideModal("modalbasic");
            this.$emit("is-success"); // parent handles close modal and refresh table
          } catch (error) {
            this.submitting = false;
            this.successMsg = "";
            this.errorMsg = error.message;
            this.$notify("error filled", "Failed", this.errorMsg, {
              duration: 3000,
              permanent: false,
            });
          }
        }
      }
    },
    confirmChanges() {
      this.confirmSubmit = true;
      this.onValidateFormSubmit("skipModal");
    },
    hideModal(refname) {
      this.$refs[refname].hide();

      if (refname === "modalnestedinline") {
        this.$refs["modalnested"].show();
      }
      if (refname === "modalbasic") {
        this.confirmSubmit = false;
      }
    },
    somethingModal(refname, props) {
      this.$refs[refname].hide();

      if (refname === "modalbasic") {
        this.$refs["modalbasic"].show();
      }
    }
  },
  watch: {
    confirmSubmit(val) {
      this.confirmSubmit = val;
    },
    guest: {
      deep: true,
      handler(newGuest) {
        this.horizontalForm = { ...newGuest };
      },
    },
  }
};
</script>
